/* ESP32_pwm_ledfade
 * 
 * LED vezérlése egy PWM csatorna felhasználásával.
 * A kitöltést periodikusan és lineárisan változtatjuk
 * 
 * Hardver: 
 * ESP32-WROOM-32 Devkit-V1 kártya 
 * Egy LED anódja a GPIO19 kiementre kötve (egy 220 ohmos
 * áramkollátozó ellenálláson keresztül), katódja pedig a 
 * GND-re kötve.
 * 
 * A programhoz felhasználtuk 
 * Kaled Magdy: ESP32 PWM LED Control c. mintaláldáját
 * https://deepbluembedded.com/esp32-pwm-tutorial-examples-analogwrite-arduino/
 * 
 * Arduino 1.8.15 és ESP32 2.0.0 kiadással tesztelve
 */
 
#define LED_GPIO   19
#define PWM1_Ch    0
#define PWM1_Res   8
#define PWM1_Freq  1000
 
int PWM1_DutyCycle = 0;
 
void setup() {
  ledcAttachPin(LED_GPIO, PWM1_Ch);
  ledcSetup(PWM1_Ch, PWM1_Freq, PWM1_Res);
}
 
void loop() {
  while(PWM1_DutyCycle < 255) {
    ledcWrite(PWM1_Ch, PWM1_DutyCycle++);
    delay(10);
  }
  while(PWM1_DutyCycle > 0) {
    ledcWrite(PWM1_Ch, PWM1_DutyCycle--);
    delay(10);
  }
}
