/* ESP32_pwm_music
 * 
 * Zenelejátszás egy PWM csatorna felhasználásával.
 * A keltett hangot egy passzív piezo csipogóval
 * szólaltatjuk meg, amelyet a GPIO23 kimenetre kötünk.
 * 
 * Hardver: 
 * ESP32-WROOM-32 Devkit-V1 kártya 
 * Piezo buzzer (passzív): GPIO23 és a GND közé kötve
 * 
 * A program hoz felhasználtuk Toulson és Tim Wilmshurst: 
 * ARM mbed Course Material - PWM mintapéldáját
 * Link: https://developer.mbed.org/cookbook/Course-Notes
 * 
 * Arduino 1.8.15 és ESP32 2.0.0 kiadással tesztelve
 */
#define buzzer_pin 23
#define buzzer_chan 0

int frequency[] = {659, 554, 659, 554, 550, 494, 554, 587, 494, 659, 554, 440}; //frequency array
int beat[] = {4, 4, 4, 4, 4, 8, 8, 4, 4, 4, 4, 2};                              //beat array

void setup() {
  // Itt nincs tennivalónk
}


void loop() {
  ledcAttachPin(buzzer_pin, buzzer_chan);
  for (int i = 0; i < 12; i++) {
    ledcWriteTone(buzzer_chan, frequency[i]);  // Hang frekvenciájának beállítása
    delay(2000 / beat[i]);                     // kitartjuk a hangot az előírt ideig
  }
  ledcDetachPin(buzzer_pin);                   // Leválasztjuk a kimenetet
  delay(2000);                                 // Csendes pihenő (2 s)
}
